class DateisController < ApplicationController
  
  auto_complete_for :datei, :modul
         
  def index
    render :template => "application/index"
  end

  # <b>list</b> liest alle vorhandenen Datenstze ein
  # und bereitet sie fr die Treelist auf.

   def list
    view_tree("noDB")
    render :partial => "application/nav", :controller => "application"
  end
 
  def edit
    @datei = Datei.find(params[:id])
    @felds  = Feld.find_all_by_datei(@datei.id)
  end
 
  def list_modul
    parent  = next_parent(params[:html_id], params[:html_name])
    @dateis = Datei.find_all_by_modul(params[:key], :conditions => ["datenbank = ? ", parent] )    
    params[:parent] = parent
  end
 
  def edit_called_by_tree
    parent  = next_parent(params[:html_id], params[:html_name],1)
    @datei = Datei.find_by_name(params[:key], :conditions => ["datenbank = ? ", parent])
    unless @datei
      @info           = ['error', 'main', 0]
      flash[:notice]  = "Dateibeschreibung \"#{params[:key]}\" fehlt => bitte Datenbank aktualisieren"  
      render :template => "application/index"
    else
      @felds  = Feld.find_all_by_datei(@datei.id)
      render :action => 'edit'
    end
  end
  
  def update
    @datei  = Datei.find(params[:id])
    modul    = @datei.modul
    if @datei.update_attributes(params[:datei])
      info                = ['hinweis', 'main']
      notice              = 'Der Datensatz wurde erfolgreich ge&auml;ndert.'
    else      
      info, notice, msg   = ['error', 'main', 0], "", []
      @datei.errors.each {|attr, msg| notice << "#{msg}<br>"}  
      flash[:notice]      = notice
    end
    unless modul == @datei.modul 
      view_tree("noDB", "", "clear")
    end
    @felds  = Feld.find_all_by_datei(@datei.id)
    @info           = info
    flash[:notice]  = notice  
    render :action  => 'edit'        
  end

  def classifier 
    @datei = Datei.find(params[:id])
    @datei.check = {'classifier', params[:input]}
    flash[:notice] = @datei.errors.on('classifier')  unless @datei.valid?
    text = @datei.errors.count > 0 ? "<div class=\"popup_error\"><%= flash[:notice] %></div>" : ""
    render :inline => text
  end
  
  ######################################################################################################    
  
  private
         
end     # class
