class FeldsController < ApplicationController

  helper_method             :list, :list_leichen 

  def edit_called_by_tree
    info  = felds(params[:idnr])
    unless info.empty?
      redirect_to :action => "message", :controller => 'application' , :confirm => info
    else
      render :action    => 'edit'
    end
  end
  
  def edit
    params[:idnr] = params[:id]     unless params[:idnr]
    edit_called_by_tree     if params[:idnr].to_i > 0
  end

  # <b>list</b> listet alle Feld-Datenstze auf
  
  def list(error=false)
    @feld_pages       = Paginator.new self, Feld.count, 20, @params[:page]
    if error
      options         = [ "eigenschaft = ? AND datei != ? ", 0, @@gone]   if error      # Fehlerhafte Stze sind solche ohne Eigenschaft - aber keine "Leichen"
      params[:error]  = true
    else
      if params[:key]
        cdb           = params[:key]
        Save_me.new(['cdb', 0], cdb)
      else
        cdb           = Save_me.new(['cdb', 0]).saved
      end
      options         = Feld.cond_dbs(cdb, '', 'yes')
    end
    unless options.nil? 
      @felds            =  Feld.find :all, :conditions => options,
                            :order => 'datei, name',
                            :limit  =>  @feld_pages.items_per_page,
                            :offset =>  @feld_pages.current.offset
      render :action => 'index'
    else
      info                = ['edit', 'hinweis', "F&uuml;r #{cdb} sind keine S&auml;tze vorhanden." ]
      redirect_to :action => "message", :controller => 'application' , :confirm => info      
    end
  end

  # <b>list_error</b> listet nur die fehlerhaften Stze auf  

  def list_error
    list(true)
  end
  
  # <b>list_leichen</b> listet nur die berzhligen Stze auf, unabhngig vom Dateisystem  

  def list_leichen
    @leftover         = Feld.find_all_by_datei(@@gone)
    params[:leichen]  = true
    render :action    => 'index'
  end  

  # <b>update</b> aktualisiert den Datensatz
  # Besonderheit: Felder werden nie angelegt oder gelscht - nur ber "datenbank.rb" aus der physikalischen Datenbank heraus

  def update      
    info          = felds(params[:id])
    unless info.empty?
      render :partial => "application/message", :locals => {:confirm => info}   
    else     
      do_save         # incl. render
    end
  end

  # <b>destroy</b> lscht das berzhlige Feld
  
  def destroy
    Feld.find(params[:id]).destroy
    redirect_to :action => 'list_leichen'
  end
  
  # <b>reset</b> fhrt das Reset aus fr Edit-Templates aus
  
  def reset
    felds(params[:id])
    render :partial => "edit", :locals => {:function => {'reset' => ''} }
  end
  
  # <b>anzahl</b> prft den bergebenen Wert
  
  def anzahl
    @feld       = Feld.find(params[:id])
    input       = params[:input].scan(/[0-9]+|\w+/)    # aus :with
    @feld.check = {'anzahl', input[0]}
    @feld.cond  = {'anzahl', input[1]}
    notice      = ''
    notice      = notice + @feld.errors.on('anzahl') + '<br>'   unless @feld.valid?
    notice      = notice + @feld.info('anzahl')
    flash[:notice] = notice
    unless notice.empty?
      text  =  "<div class=\"popup_error\"><%= flash[:notice] %></div>
                  <script type='text/javascript'>
                      //<![CDATA[
                      $('feld_anzahl').value = #{@feld.check['anzahl']}
                      //]]>  
                  </script>"
    else
      text  = ""
    end
    render :inline => text
  end
   
  # <b>droptext</b> ermittelt die Drop-Texte
  
  def droptext(id, index, dropped)
    modul = "Feld"
    case index
    when 0
      modul = "Eigenschaft"
      tt    = 'Um die Eigenschaft zu &auml;ndern, einfach dieses Icon auf die gew&uuml;nschte Eigenschaft ziehen.'
      del   = ''        #    Eigenschaft ist erforderlich - nderung ja, Lschen nein
    when 1
      tt    = "Soll ein f&uuml;hrendes Feld als Redundanz des vorliegenden Feldes bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen"    
      del   = 'L&ouml;scht das f&uuml;hrende Feld'   
    when 2
      tt    = "Soll ein Vorg&auml;nger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen"    
      del   = 'L&ouml;scht den Vorg&auml;nger'   
    else
      tt    = "Soll ein Nachfolger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen"    
      del   = 'L&ouml;scht den Nachfolger'   
    end
    begin
      me  = eval("#{modul}.find(dropped.to_i)")   if dropped.to_i > 0
    rescue
    end
    result  = me.nil? ? ['', '', 0] : [me.name, me.beschreibung, me.id]
    result  << tt
    result  << del
    result  << ( (@feld.redundant > 0) && (index != 1)   ?  'hide': '' )
    result
  end
  
  ######################################################################################################    
  
  private

  # <b>dropped</b> bearbeitet den Drag-Drop-Vorgang

  def dropped(view, dropped, idnr)
    index     = idnr[1].to_i    
    case index
    when 0
      feldname  = 'eigenschaft'
      tooltip   = 'Um die Eigenschaft zu &auml;ndern, einfach dieses Icon auf die gew&uuml;nschte Eigenschaft ziehen.'
    when 1
      feldname  = 'redundant'
      tooltip   = 'Soll ein f&uuml;hrendes Feld als Redundanz des vorliegenden Feldes bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen.'
    when 2
      feldname  = 'vorgaenger'
      tooltip   = 'Soll ein Vorgnger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen.'
    else
      feldname  = 'nachfolger'
      tooltip   = 'Soll ein Nachfolger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen.'
    end
    msg = ''

    if view == 'NaviSeite-2' && index != 0 && dropped.to_i > 0
      msg               = 'Es wurde die &Auml;nderung eines Feldes angefordert. Bitte in die Anzeige f&uuml;r Felder wechseln.' 
    elsif view != 'NaviSeite-2' && index == 0 && dropped.to_i > 0
      msg               = 'Es wurde die &Auml;nderung einer Eigenschaft angefordert. Bitte in die Anzeige f&uuml;r Eigenschaften wechseln.' 
    else
      info              = felds(idnr[0].to_i)
      if info.empty?
        if dropped.to_i > 0  
          @feld.check      = {feldname, dropped}
          ok                = @feld.valid?
        else
          dropped           = 0
          ok                = true
        end
        if ok
          @dropdrag[index]  = dropped 
        elsif @feld.errors.count > 0
          msg               = @feld.errors.on(feldname) || ''    
        end
      else
        msg = "Der Vorgang konnte f&uuml;r diese Eigenschaft aus folgendem Grund nicht ausgef&uuml;hrt werden:<br>" + info[2]
      end
    end
    msg             <<  @feld.info(feldname)
    todo            = "$('feld_anzahl').value    = #{@feld.anzahl}" if index == 0 && dropped != @feld.eigenschaft     # todo ist nur fr Eigenschaftsnderungen vorgesehen, braucht aber die ber valid? genderten Attribute
    flash[:notice]  = msg
    msg             = (msg.nil? || msg.empty?) ? '' : "<div class=\"popup_error\">#{flash[:notice]}</div>"
    return [@dropdrag, msg, todo]
  end

  # <b>do_save</b> fhrt die Prfungen und Aktualisierungen fr update aus ("new" existiert fr Felder nicht)
  
  def do_save
    dropped             = [params[:drop_mem_0], params[:drop_mem_1], params[:drop_mem_2], params[:drop_mem_3]]    # Name der Hidden-Felde
    prv                 = [@feld.eigenschaft, @feld.redundant, @feld.vorgaenger, @feld.nachfolger]

    endstation          = params[:endstation].nil? ? false : true      # ist die Checkbox nicht angeklickt - so ist sie nil
    if endstation == true
      dropped[3]          = '-1'
    end            
    
    attr                  = @feld.attributes
    @feld.attributes      = params[:feld]
    @feld.check           = { 'eigenschaft'   => dropped[0],
                              'redundant'     => dropped[1],
                              'vorgaenger'    => dropped[2],
                              'nachfolger'    => dropped[3],
                              'beschreibung'  => @feld.beschreibung, # ggf. Unterlassungswert einfgen
                              'anzahl'        => @feld.anzahl}       # ggf. Unterlassungswert einfgen
                            
    if @feld.valid?        # setzt ber call_record auch die attribute von @check
      ok  = true
    else
      ok  = false
    end
    todo  = attr != @feld.attributes
    if ok 
      @feld.save_me(prv)    if todo
      @dropdrag           = [@feld.eigenschaft, @feld.redundant, @feld.vorgaenger, @feld.nachfolger]      # Aktualisierung der Instanzvariablen

      if prv[0] == 0        # Fehleranzeige im Baum korrigieren
        view_tree("noDB", "", "clear")
      end      
      
      # Rendering
      function            = {}      # Javascript-Funktionen fr Rendering
      function['reload']  = ''      if todo   # liest die gesamte Seite neu ein, um auch die Ajax-Werte "festzuschreiben"       

      render :partial => "edit", :locals => {:function => function}    

    else                # Fehler
      notice, msg           = "", []
      @feld.errors.each {|attr, msg| notice << "#{msg}<br>"}
      confirm               = ['edit', 'error', notice ]
      render :partial => "edit", :locals => {:confirm => confirm}  
    end
  end

  # <b>felds</b> ermittelt den Satz, bestimmt die Werte bei neu anzulegenden oder gibt Fehler aus
  # Besonderheit: Felder werden nie angelegt - nur ber "datenbank.rb" aus der physikalischen Datenbank heraus
 
  def felds(id, todo = '')
    info                  = []
    begin
      @feld              = Feld.find(id)   # id muss existieren
    rescue
      notice              = "Das angeforderte Feld mit der Satznummer \"#{id}\" konnte nicht gefunden werden. 
                            Wenn das Feld gel&ouml;scht wurde, k&ouml;nnte dies daran liegen, dass Sie auf einen &uuml;berholten Stand der Anzeige gebl&auml;ttert haben 
                            und l&auml;sst sich durch \"Neuladen\" des Browsers bereinigen.<br>
                            Ansonsten k&ouml;nnte eine Datenbank-Aktualisierung das Problem bereinigen."
      if todo == '-1'
        notice  = ''
        feld(id.to_i-1, todo)
      end
      info                = ['edit', 'error', notice ]    unless notice.empty?
    end
  
    # Ergebnisse
    if @feld
      @dropdrag         = [@feld.eigenschaft, @feld.redundant, @feld.vorgaenger, @feld.nachfolger]
      @new              = false
    end
    info
    
  end

end
