class DateisController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    @dateis_pages, @dateis = paginate :dateis, :per_page => 10
  end

  def show
    @dateis = Datei.find(params[:id])
  end

  def new
    @dateis = Datei.new
  end

  def create
    @dateis = Datei.new(params[:dateis])
    if @dateis.save
      flash[:notice] = 'Dateis was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @dateis = Datei.find(params[:id])
  end

  def update
    @dateis = Datei.find(params[:id])
    if @dateis.update_attributes(params[:dateis])
      flash[:notice] = 'Dateis was successfully updated.'
      redirect_to :action => 'show', :id => @dateis
    else
      render :action => 'edit'
    end
  end

  def destroy
    Datei.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
